function varargout = design(varargin)
% DESIGN M-file for design.fig
%      DESIGN, by itself, creates a new DESIGN or raises the existing
%      singleton*.
%
%      H = DESIGN returns the handle to a new DESIGN or the handle to
%      the existing singleton*.
%
%      DESIGN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DESIGN.M with the given input arguments.
%
%      DESIGN('Property','Value',...) creates a new DESIGN or raises
%      the existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before design_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to design_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help design

% Last Modified by GUIDE v2.5 23-Apr-2024 09:48:48

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @design_OpeningFcn, ...
                   'gui_OutputFcn',  @design_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before design is made visible.
function design_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to design (see VARARGIN)

% Choose default command line output for design
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

initialize_gui(hObject, handles, false);

% UIWAIT makes design wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = design_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function density_CreateFcn(hObject, eventdata, handles)
% hObject    handle to density (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function density_Callback(hObject, eventdata, handles)
% hObject    handle to density (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of density as text
%        str2double(get(hObject,'String')) returns contents of density as a double
density = str2double(get(hObject, 'String'));
if isnan(density)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.metricdata.density = density;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function volume_CreateFcn(hObject, eventdata, handles)
% hObject    handle to volume (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function volume_Callback(hObject, eventdata, handles)
% hObject    handle to volume (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of volume as text
%        str2double(get(hObject,'String')) returns contents of volume as a double
volume = str2double(get(hObject, 'String'));
if isnan(volume)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.metricdata.volume = volume;
guidata(hObject,handles)

% --- Executes on button press in calculate.
function calculate_Callback(hObject, eventdata, handles)
% hObject    handle to calculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

mass = handles.metricdata.density * handles.metricdata.volume;
set(handles.mass, 'String', mass);

% --- Executes on button press in reset.
function reset_Callback(hObject, eventdata, handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

initialize_gui(gcbf, handles, true);

% --------------------------------------------------------------------
function unitgroup_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to unitgroup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (hObject == handles.english)
    set(handles.text4, 'String', 'lb/cu.in');
    set(handles.text5, 'String', 'cu.in');
    set(handles.text6, 'String', 'lb');
else
    set(handles.text4, 'String', 'kg/cu.m');
    set(handles.text5, 'String', 'cu.m');
    set(handles.text6, 'String', 'kg');
end

% --------------------------------------------------------------------
function initialize_gui(fig_handle, handles, isreset)
% If the metricdata field is present and the reset flag is false, it means
% we are we are just re-initializing a GUI by calling it from the cmd line
% while it is up. So, bail out as we dont want to reset the data.
if isfield(handles, 'metricdata') && ~isreset
    return;
end

handles.metricdata.density = 0;
handles.metricdata.volume  = 0;

%set(handles.density, 'String', handles.metricdata.density);
%set(handles.volume,  'String', handles.metricdata.volume);
%set(handles.mass, 'String', 0);

%set(handles.unitgroup, 'SelectedObject', handles.english);

%set(handles.text4, 'String', 'lb/cu.in');
%set(handles.text5, 'String', 'cu.in');
%set(handles.text6, 'String', 'lb');

% Update handles structure
guidata(handles.figure1, handles);


% --- Executes on button press in pushbutton51.
function pushbutton51_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton51 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

muplot;

% --- Executes on button press in pushbutton38.
function pushbutton38_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton38 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

gsdata;


% --- Executes on button press in pushbutton39.
function pushbutton39_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton39 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

w2data;


% --- Executes on button press in pushbutton40.
function pushbutton40_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton40 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

wdel2data;


% --- Executes on button press in pushbutton41.
function pushbutton41_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton41 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

w1datadk;


% --- Executes on button press in pushbutton42.
function pushbutton42_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton42 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
dkdata;

% --- Executes on button press in pushbutton43.
function pushbutton43_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton43 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

aadata;

% --- Executes on button press in pushbutton44.
function pushbutton44_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton44 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

dkitTd;

% --- Executes on button press in asdm.
function asdm_Callback(hObject, eventdata, handles)
% hObject    handle to asdm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

asdm;

% --- Executes on button press in pushbutton46.
function pushbutton46_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton46 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global noaa;

if noaa==1
    Err02;
else
    simplex;
end

% --- Executes on button press in pushbutton47.
function pushbutton47_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton47 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global b0 a1 Td1 Td2;
global b_kdk a_kdk;
global out4;
global nodk;

if nodk==1
    Err05;
else
    sl1dofDK;
end

% --- Executes on button press in pushbutton48.
function pushbutton48_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton48 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

warning off;

global b0 a1 Td1 Td2;
global b_kdk a_kdk dkoa;
clear out4;
global out4 o2;
global nodk;
global no2dofdk;

if nodk==1
    Err05;
else if no2dofdk
        Err08;
    else
        sl2dofDK
    end
end

% --- Executes on button press in pushbutton49.
function pushbutton49_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton49 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global noaa;

if noaa==1
    Err06;
else
    sl1dofaa;
end


% --- Executes on button press in pushbutton50.
function pushbutton50_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton50 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global noaa o6 qStore1 pStore1 qStore2;
global no2dofaa;

if noaa==1
    Err06;
else if no2dofaa
        Err08;
    else
        sl2dofaa;
    end
end


% --- Executes on button press in oneplotaa.
function oneplotaa_Callback(hObject, eventdata, handles)
% hObject    handle to oneplotaa (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% global out1;

% if exist('out1')
%    if ~isempty(out1)
%        graftdaa;
%    end
%end
%if ~exist('out1')
%    Err03;
%else
%    if isempty(out1)
%        Err03;
%    end
%end

global dk1 dk2 dk1p dk2p aa1 aa2 aa1p aa2p;
global o1 o2 o3 o4 o5 o6 o7 o8;
global out1;
global out4;

clear out1;
clear out4;

first=0;
if dk1==1 && exist('o1')
    out1=o1;
    leg11='Output - D-K iteration 1DOF';
    leg12='Control signal - D-K iteration 1DOF';
    first=1;
end    
if dk2==1 && exist('o2')
    if first==0
        out1=o2;
        leg11='Output - D-K iteration 2DOF';
        leg12='Control signal - D-K iteration 2DOF';
        first=1;
    else
        out4=o2;
        leg21='Output - D-K iteration 2DOF';
        leg22='Control signal - D-K iteration 2DOF';
    end
end    
if aa1==1 && exist('o5')
    if first==0
        out1=o5;
        leg11='Output - alg. approach 1DOF';
        leg12='Control signal - alg. approach 1DOF';
        first=1;
    else
        out4=o5;
        leg21='Output - alg. approach 1DOF';
        leg22='Control signal - alg. approach 1DOF';
    end
end    
if aa2==1 && exist('o6')
    if first==0
        out1=o6;
        leg11='Output - alg. approach 2DOF';
        leg12='Control signal - alg. approach 2DOF';
        first=1;
    else
        out4=o6;
        leg21='Output - alg. approach 2DOF';
        leg22='Control signal - alg. approach 2DOF';
    end
end    

if exist('out1')
    if ~isempty(out1)
        graftdaa2(out1);
        if exist('out4')
            if ~isempty(out4)
                graftddk2(out4);
                legend('Reference',leg11,leg12,leg21,leg22);
            else
                legend('Reference',leg11,leg12);
            end
        else
            legend('Reference',leg11,leg12);
        end
        title('Simulation');
        xlabel('Time');
        hold off;
    end
end

if ~exist('out1')
    if dk1p == 1 || dk2p == 1 || aa1p == 1 || aa2p == 1
        Err12;
    else
        Err03;
    end
else
    if isempty(out1)
        if dk1p == 1 || dk2p == 1 || aa1p == 1 || aa2p == 1
            Err12;
        else
            Err03;
        end
    end
end


% --- Executes on button press in aagetc.
function aagetc_Callback(hObject, eventdata, handles)
% hObject    handle to aagetc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global poleno poleno_hObject;
global deg_x;

aagetc;
if poleno>deg_x-1
    set(poleno_hObject, 'Value',deg_x-1);
    poleno=deg_x-1;
end


% --- Executes on button press in w1aa.
function w1aa_Callback(hObject, eventdata, handles)
% hObject    handle to w1aa (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

w1data;





function devra_Callback(hObject, eventdata, handles)
% hObject    handle to devra (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of devra as text
%        str2double(get(hObject,'String')) returns contents of devra as a double

global devra devraErr;
tmp=str2double(get(hObject,'String'));
if tmp>=0 || tmp<0
    devra=tmp;
    devraErr=0;
else
    Err01;
    devraErr=1;
end

% --- Executes during object creation, after setting all properties.
function devra_CreateFcn(hObject, eventdata, handles)
% hObject    handle to devra (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

global devra devratmp;
set(hObject, 'String', num2str(devra));



% --- Executes on selection change in poleno.
function poleno_Callback(hObject, eventdata, handles)
% hObject    handle to poleno (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns poleno contents as cell array
%        contents{get(hObject,'Value')} returns selected item from poleno

global poleno deg_x;

tmp=get(hObject,'Value');
poleno=tmp;
if poleno>deg_x-1
    set(hObject,'Value',deg_x-1);
    poleno=deg_x-1;
end
    

% --- Executes during object creation, after setting all properties.
function poleno_CreateFcn(hObject, eventdata, handles)
% hObject    handle to poleno (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

global poleno_hObject;
global poleno deg_x;

poleno_hObject=hObject;
set(hObject,'Value',1);
poleno=1;


% --- Executes on button press in about.
function about_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton41 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

about;


% --- Executes on button press in plotopt.
function plotopt_Callback(hObject, eventdata, handles)
% hObject    handle to plotopt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

plotopt;

% --- Executes on button press in pushbutton59.
function oneplotpert_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton59 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global noaa nodk no2dofaa no2dofdk;
global dk1 dk2 dk1p dk2p aa1 aa2 aa1p aa2p;

errtmp = 1;
if aa1 == 1 && noaa ~= 1
    errtmp = 0;
end
if aa1p == 1 && noaa ~= 1
    errtmp = 0;
end
if aa2 == 1  && ~no2dofaa
    errtmp = 0;
end
if aa2p == 1 && ~no2dofaa
    errtmp = 0;
end
if dk1 == 1 && nodk ~= 1
    errtmp = 0;
end
if dk1p == 1 && nodk ~= 1
    errtmp = 0;
end
if dk2 == 1 && ~no2dofdk
    errtmp = 0;
end
if dk2p == 1 && ~no2dofdk
    errtmp = 0;
end
if errtmp == 1
    Err04;
else
    evalc( 'trpert' );
end